// Naive implementation of a signaling less-than-or-equal comparison
// between a binary64 and a decimal64
// 
// Copyright (C) 2012, 2013 by
// 
// Laboratoire de l'Informatique du Parallelisme,
// UMR CNRS - ENS Lyon - UCB Lyon 1 - INRIA 5668
// 
// and by
// 
// Laboratoire d'Informatique de Paris 6, equipe PEQUAN,
// UPMC Universite Paris 06 - CNRS - UMR 7606 - LIP6, Paris, France.
// 
// Authors : Christoph Lauter, Marc Mezzarobba
// 
// Contact : christoph.lauter@lip6.fr, marc@mezzarobba.net
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.
// 

#include <stdio.h>
#include <stdint.h>

/* Get our constants and types */
#include "comparison.h"

#include <math.h>

/* Compile me with something like 

    icc -xSSE4.2 -O3 -c -o comparison-naive.o comparison-naive.c 

*/

/* This is one of the two possible naive versions for comparing 
   a binary64 and a decimal64.

   It's just a decimal64 comparison after a conversion of the 
   binary value to a decimal64.

   AS A MATTER OF COURSE, THIS NAIVE IMPLEMENTATION IS NOT CORRECT.
*/
int compareSignalingLessEqualBinary64Decimal64(_binary64 x, _Decimal64 y) {
  return (((_Decimal64) x) <= y);
}


/* An empty dummy function in this translation unit for timing purposes */
int emptyFunctionBinary64Decimal64(_binary64 x, _Decimal64 y) {
  return 1;
}
